/******************************************************
 *  Systemy Mikroprocesorowe w Sterowaniu,  WEiTI PW 	*
 *  ZL27ARM: PROJEKT_01 diody LED  						 				*
 ******************************************************/
#include "stm32f10x.h"
#include <stdbool.h> 		// true, false

int  RCC_Config(void);
void GPIO_Config(void);
void Delay(unsigned int);

int main(void) {
  unsigned delay = 1000000; // = 0.25 sekundy opóźnienia
	volatile unsigned int i = 1;
	int k;
	uint16_t GPIO_Pin_x;

  //konfiguracja systemu
  RCC_Config();		
  GPIO_Config(); 
  GPIO_ResetBits(GPIOB, 0xFF00u);	// zgasimy wszystkie diody LED
	
	// pomiar opóźnienia -------------------------------------------------------
/*
	GPIO_SetBits(GPIOB, 0xFF00u);	// zapalimy wszystkie diody LED
	Delay(3*8000000);
	GPIO_ResetBits(GPIOB, 0xFF00u);	// zgasimy wszystkie diody LED
	GPIO_WriteBit(GPIOB, GPIO_Pin_8, Bit_SET);
	Delay(0xFFFFFFFF);
	GPIO_SetBits(GPIOB, 0xFF00u);	// zapalimy wszystkie diody LED
*/
  while (1) {
    // *************************  słupek lewo - prawo ************************
		GPIO_Pin_x = GPIO_Pin_8;
		for (k=0; k<8; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_SET);
			Delay(delay);
			GPIO_Pin_x *= 2;
		}
		i++;
		i = i & 0x07;
		GPIO_Write(GPIOE, i);
		GPIO_Pin_x = GPIO_Pin_8;
		for (k=0; k<8; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_RESET);
			Delay(delay);
			GPIO_Pin_x *= 2;
		}
		i++;
		i = i & 0x07;
		GPIO_Write(GPIOE, i);
		GPIO_Pin_x = GPIO_Pin_15;	
		for (k=0; k<8; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_SET);
			Delay(delay);
			GPIO_Pin_x /= 2;
		}
		i++;
		i = i & 0x07;
		GPIO_Write(GPIOE, i);
		GPIO_Pin_x = GPIO_Pin_15;	
		for (k=0; k<8; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_RESET);
			Delay(delay);
			GPIO_Pin_x /= 2;
		}
		i++;
		i = i & 0x07;
		GPIO_Write(GPIOE, i);
  }
//  return 0;  // tego 'return' nigdy nie osiągnie 
}
//------------ konfiguracja RCC: sygnały taktujące ------------
int RCC_Config(void) {
  ErrorStatus HSEStartUpStatus;                          // zmienna opisująca rezultat uruchomienia HSE

  RCC_DeInit();                                          // RCC na 'default reset state'
  RCC_HSEConfig(RCC_HSE_ON);                             // włącz HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            // czekaj na gotowość HSE
  if(HSEStartUpStatus == SUCCESS) {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//
    FLASH_SetLatency(FLASH_Latency_2);                   // zwłoka Flasha: 2 takty dla 72MHz
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                     // HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      // PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      // PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); // PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
    RCC_PLLCmd(ENABLE);                                  // włącz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  // czekaj na uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           // ustaw PLL jako źródło sygnału zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                // czekaj aż PLL będzie sygnałem zegarowym systemu
// konfiguracja sygnałów taktujących używanych peryferii 
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);// włącz taktowanie portu GPIO B
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);// włącz taktowanie portu GPIO E
		return 0;
  }
	else
		return 1;
}
//------------------ konfiguracja portów GPIO -----------------
void GPIO_Config(void) {
  GPIO_InitTypeDef  GPIO_InitStructure; 

  // LED1 ... LED8 na płytce
  GPIO_InitStructure.GPIO_Pin = 0xFF00u; 	// piny 15,14,...9,8
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjście w trybie push-pull
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	// LED zewnętrzny (kolorowy)
	GPIO_InitStructure.GPIO_Pin = 0x0007; 	// piny 2,1,0
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjście w trybie push-pull
  GPIO_Init(GPIOE, &GPIO_InitStructure);
}

void Delay(unsigned int counter){
	// opóźnienie programowe, 8'000'000 to jedna sekunda
	while (counter--){
		__NOP();
		__NOP();
	}
}





