/******************************************************
 *  Systemy Mikroprocesorowe w Sterowaniu,  WEiTI PW 	*
 *  ZL27ARM: PROJEKT_02 wyswietlacz LCD  asembler			*
 ******************************************************/
#include "stm32f10x.h"
#include <stdbool.h> 		// true, false
#include <stdio.h>
#include "lcd_1602.h"

int  RCC_Config(void);
void GPIO_Config(void);

int main(void) {
	unsigned int k;
	unsigned delay = 6000000; // = 3/4 sekundy opóźnienia
	uint16_t GPIO_Pin_x;
	
  //konfiguracja systemu
  RCC_Config();		
  GPIO_Config(); 
  GPIO_ResetBits(GPIOB, 0xFF00u);		// zgasimy wszystkie diody LED																									
	LCD_Initialize();                 // inicjalizacja wyświetlacza
	
	LCD_WriteText((unsigned char *)"Systemy Mikroprocesorowe w Sterowaniu\0");
	LCD_GoTo(0,1);
	LCD_WriteText((unsigned char *)"     WEiTI Politechnika Warszawska\0");
	
	while (1) {
		// ************************* LEDy lewo - prawo ************************
		for (k=0; k<9; k++) {
			LCD_SendCommand(LCD_DISPLAY_CURSOR_SHIFT | LCD_SHIFT_DISPLAY); 
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_SET);
			GPIO_Write(GPIOE, k);
			delay_us(delay);
			GPIO_Pin_x = GPIO_Pin_8 << (k);
		}
		for (k=0; k<9; k++) {
			LCD_SendCommand(LCD_DISPLAY_CURSOR_SHIFT | LCD_SHIFT_DISPLAY); 
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_RESET);
			GPIO_Write(GPIOE, k);
			delay_us(delay);
			GPIO_Pin_x = GPIO_Pin_8 << (k);
		} 
  }
}
//------------ konfiguracja RCC: sygnały taktujące ------------
int RCC_Config(void) {
  ErrorStatus HSEStartUpStatus;                          // zmienna opisująca rezultat uruchomienia HSE

  RCC_DeInit();                                          // RCC na 'default reset state'
  RCC_HSEConfig(RCC_HSE_ON);                             // włącz HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            // czekaj na gotowość HSE
  if(HSEStartUpStatus == SUCCESS) {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//
    FLASH_SetLatency(FLASH_Latency_2);                   // zwłoka Flasha: 2 takty dla 72MHz
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                     // HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      // PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      // PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); // PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
    RCC_PLLCmd(ENABLE);                                  // włącz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  // czekaj na uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           // ustaw PLL jako źródło sygnału zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                // czekaj aż PLL będzie sygnałem zegarowym systemu
// konfiguracja sygnałów taktujących używanych peryferii 
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);// włącz taktowanie portu GPIO B ( LEDy  ) 
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);// włącz taktowanie portu GPIO C (LCD1602)
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);// włącz taktowanie portu GPIO E (LED zewnętrzny)
		return 0;
  }
	else
		return 1;
}
//------------------ konfiguracja portow GPIO -----------------
void GPIO_Config(void) {
  GPIO_InitTypeDef  GPIO_InitStructure; 

  // LED1 ... LED8 na płytce
  GPIO_InitStructure.GPIO_Pin = 0xFF00u; 	// piny 15,14,...9,8
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjście w trybie push-pull
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	// LED zewnętrzny (kolorowy)
	GPIO_InitStructure.GPIO_Pin = 0x0007; 	// piny 2,1,0
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjście w trybie push-pull
  GPIO_Init(GPIOE, &GPIO_InitStructure);
}













