;********************************************
;* Programy asemblerowe     04-02-2016		*
;********************************************
			AREA AsmCode, CODE, READONLY
				
;----------------- parityBit -----------------
;INPUT:  r0 = bajt (8 bitow)
;OUTPUT: r0 = 0 gdy parzysta ilosc jedynek
;        r0 = 1 gdy nieparzysta ilosc jedynek
; bit parzystosci w transmisji szeregowej
			EXPORT parityBit
			ALIGN
parityBit	PROC
			MOVS r1,#0		; r1 = licznik jedynek
			MOVS r2,#8		; r2 = licznik petli
			MOV  r3,r1		; r3 = 0 do dodawania Carry
label01		LSRS r0,r0,#1	; przesun b0 do Carry
			ADC  r1,r3		; r1 = r1 + 0 + C
			SUBS r2,r2,#1	; dekrementuj licznik petli
			BNE  label01	; skocz gdy Z != 0
			MOVS r0,#0
			LSRS r1,r1,#1	; b0 licznika jedynek do C
			BCC  label02	; skocz, gdy C = 0
			ADC  r0,r0		; r0 = 0 + 0 + 1
label02		BX   lr
			ENDP
				
;---------------- maxLocation ----------------
;INPUT:  r0 = adres poczatku tablicy
;        r1 = dlugosc tablicy
;OUTPUT: r0 = numer maksymalnego elementu 
;             tablicy (liczac od zera)
			EXPORT maxLocation
			ALIGN
maxLocation	PROC
			PUSH {r3-r5,lr}	; parzysta ilosc rejestrow
			MOV  r2,r0		; adres poczatku tablicy
			LDR  r4,[r2]	; maksymalna liczba
			MOVS r0,#0		; indeks maksymalnej
			MOVS r3,#1		; licznik petli
			B    label05
label03		LDR  r5,[r2,r3,LSL #2] 	; r5 = kolejna liczba
			CMP  r5,r4		; czy kolejna wieksza od max
			BLE  label04	; skocz gdy nie
			LDR  r4,[r2,r3,LSL #2] 	; kolejna jest najwieksza
			MOV  r0,r3		; r0 = indeks najwiekszej
label04		ADDS r3,r3,#1	; i++ inkrementuj licznik petli
label05		CMP  r3,r1		; czy koniec tablicy
			BCC  label03	; skocz gdy C = 0
			POP  {r3-r5,pc}
			ENDP				
				

;--------------- countDigits ---------------
;unsigned int countDigits(int);
;INPUT:  r0 = liczba 'int'
;OUTPUT: r0 = ilosc cyfr 'unsigned int'
; funkcja zwraca ilosc cyfr dziesietnych
; w liczbie ze znakiem
			EXPORT countDigits
			ALIGN
countDigits	PROC
			MOV r1,#0		; licznik cyfr
			MOV r2,#10		; podzielnik
label93		CBZ	r0,label94	; gdy r0 = 0 to koniec
			SDIV r0,r0,r2	; r0 = r0 /10
			ADD r1,r1,#1	; inkrementuj licznik
			B label93		; to jeszcze nie koniec
label94		MOV r0,r1		; licznik do r0
			BX  lr			; powrot
			ENDP

;---------------- Armstrong ----------------
;int Armstrong(int);
;INPUT:  r0 = liczba 'int'
;OUTPUT: r0 = 1,  gdy Armstrong
; 		 r0 = 0,  not Armstrong
; funkcja sprawdza czy 'Armstrong Number'
; 153,370,371,407, 1634,8208,9474
; 54748,92727,93077, 548834
; 1741725,4210818,9800817,9926315
			EXPORT Armstrong
			ALIGN
Armstrong	PROC
			PUSH {r3-r7,lr}	; parzysta ilosc rejestrow
			MOV  r4,r0		; r4 = x
			MOV  r5,r4		; r5 = t
			MOVS r6,#0		; r6 = sum = 0
			BL countDigits
			MOV  r7,r0		; r7 = ilosc cyfr
			B label98	; koniec inicjalizacji zmiennych
label95		MOVS r3,#1		; r3 = y = 1
			MOV  r2,#0		; r2 = k = 0
			B label97
label96		MOVS r0,#0x0A
			SDIV r1,r5,r0	; y *= t%10
			MLS  r0,r0,r1,r5
			MULS r3,r0,r3
			ADDS r2,r2,#1
label97		CMP  r7,r2
			BHI  label96
			ADD  r6,r6,r3	; sum = sum + y
			MOVS r0,#0x0A
			SDIV r5,r5,r0
label98		CMP  r5,#0
			BNE  label95
			MOVS r0,#0		; FALSE
			CMP  r6,r4		; r6 = sum, r4 = x
			BNE  label99
			MOVS r0,#1		; TRUE
label99		POP  {r3-r7,pc}
			ENDP

				
			END
				





